import { Message, MessageDataTypes, MessageType } from './messages';
import { PostMessageDataTypes, PostMessageType } from './post_messages';
import { RpcMessageDataTypes, RpcMessageType } from './rpc_messages';
export interface WindowLike extends EventTarget {
    parent: WindowLike;
    opener: WindowLike | null;
    close(): void;
    postMessage(data: any, targetOrigin: string, transfer?: MessagePort[]): void;
}
export declare function sendMessage<T extends PostMessageType>(target: WindowLike, message: Message<T>, targetOrigin?: string): void;
export declare function isPermittedOrigin(origin: string, permittedOrigins: string[]): boolean;
export declare type PostMessageListener<T extends PostMessageType> = (data: PostMessageDataTypes[T], type: T, event: MessageEvent) => void;
export declare type RpcMessageListener<T extends RpcMessageType> = (data: RpcMessageDataTypes[T], type: T, event: MessageEvent) => void;
export declare type MessageListener<T extends MessageType> = (data: MessageDataTypes[T], type: T, event: MessageEvent) => void;
export declare type FilteringEventListener = (ev: MessageEvent) => boolean;
export declare function createMessageListener<T extends MessageType>(type: T, listener: MessageListener<T>): FilteringEventListener;
export interface TypedMessageEvent<T extends MessageType> extends MessageEvent {
    data: MessageDataTypes[T];
}
export declare type MessageEventListener<T extends MessageType> = (ev: TypedMessageEvent<T>) => void;
