import { RpcMessageListener, WindowLike } from './comms';
import { RpcMessage, RpcMessageType } from './rpc_messages';
export declare type UnknownMessageEventListener = (ev: MessageEvent) => void;
export declare class SecureChannel {
    private port;
    private providerEnd;
    private mainListener;
    private listeners;
    private fallbackListeners;
    static clientConnect(clientWindow: WindowLike, providerWindow: WindowLike, connectionNonce: string, timeoutMs?: number): Promise<SecureChannel>;
    static clientConnectNoTimeout(clientWindow: WindowLike, providerWindow: WindowLike, connectionNonce: string): Promise<SecureChannel>;
    static providerReadyToConnect(clientWindow: WindowLike, expectedNonce: string): Promise<void>;
    static providerConnect(providerWindow: WindowLike, permittedOrigins: string[], connectionNonce: string, timeoutMs?: number): Promise<SecureChannel>;
    private static debugLog(role, message);
    constructor(port: MessagePort, providerEnd: boolean);
    send<T extends RpcMessageType>(message: RpcMessage<T>): void;
    listen<T extends RpcMessageType>(messageType: T, listener: RpcMessageListener<T>): number;
    addFallbackListener(fallbackListener: UnknownMessageEventListener): void;
    unlisten(key: number): RpcMessageListener<any> | null;
    debugLog(message: string): void;
    dispose(): void;
}
