import { PrimaryClientConfiguration } from '../protocol/data';
import { SecureChannel } from '../protocol/secure_channel';
import { ProviderConfiguration } from './provider_config';
export declare class ProviderFrame {
    private providerConfig;
    private clientChannel;
    private clientConfig;
    private equivalentAuthDomains;
    private clientAuthDomain;
    private affiliationProvider;
    private localStateProvider;
    private credentialDataProvider;
    private interactionProvider;
    private requestInProgress;
    private closeListener;
    private window;
    private proxyLoginCredential;
    static initialize(providerConfig: ProviderConfiguration, establishTimeoutMs?: number): Promise<ProviderFrame>;
    constructor(providerConfig: ProviderConfiguration, clientChannel: SecureChannel, clientConfig: PrimaryClientConfiguration, equivalentAuthDomains: string[]);
    dispose(): void;
    private handleClose();
    private registerListeners();
    private addRpcListener<T>(type, messageHandler);
    private monitoringListener<T>(type, m, messageHandler);
    private recordRequestStart(requestId);
    private recordRequestStop();
    private handleWrapBrowserRequest(requestId);
    private handleHintRequest(requestId, options);
    private handleHintsAvailableRequest(id, options);
    private handleGetCredentialRequest(requestId, options);
    private handleSaveCredentialRequest(id, credential);
    private handleProxyLoginRequest(id, credential);
    private handleUnimplementedRequest(id, type);
    private handleUnknownMessage(ev);
    private storeForProxyLogin(credential);
    private copyCredential(credential, redactSensitive?);
    private createDisplayCallbacks(requestId);
    private getHints(options);
    private completenessScore(credential);
}
