import { Credential, CredentialHintOptions, CredentialRequestOptions, ProxyLoginResponse } from '../protocol/data';
export * from '../protocol/data';
export { OpenYoloError, ERROR_TYPES } from '../protocol/errors';
export declare const DEFAULT_REQUEST_TIMEOUT = 3000;
export interface OpenYoloApi {
    hintsAvailable(options: CredentialHintOptions): Promise<boolean>;
    hint(options: CredentialHintOptions): Promise<Credential>;
    retrieve(options: CredentialRequestOptions): Promise<Credential>;
    save(credential: Credential): Promise<void>;
    disableAutoSignIn(): Promise<void>;
    proxyLogin(credential: Credential): Promise<ProxyLoginResponse>;
}
export interface OnDemandOpenYoloApi extends OpenYoloApi {
    setProviderUrlBase(providerUrlBase: string): void;
    reset(): void;
}
export declare const openyolo: OnDemandOpenYoloApi;
