import { PasswordSpecification } from './password_spec';
export interface Credential {
    id: string;
    authMethod: string;
    authDomain?: string;
    password?: string;
    displayName?: string;
    profilePicture?: string;
    exchangeToken?: string;
    idToken?: string;
    generatedPassword?: string;
    proxiedAuthRequired?: boolean;
}
export interface CredentialToken {
    provider: string;
    token: string;
}
export interface ProxyLoginResponse {
    statusCode: number;
    responseText: string;
}
export interface CredentialRequestOptions {
    supportedAuthMethods: string[];
}
export interface CredentialHintOptions {
    supportedAuthMethods: string[];
    showAddAccount?: boolean;
    passwordSpec?: PasswordSpecification;
}
export declare type ClientConfiguration = PrimaryClientConfiguration | ReferencingClientConfiguration;
export interface PrimaryClientConfiguration {
    type: 'primary';
    apiEnabled?: boolean;
    requireProxyLogin?: boolean;
    allowNestedFrameRequests?: boolean;
    authenticationEndpoint?: string;
}
export interface ReferencingClientConfiguration {
    type: 'reference';
    domain: string;
}
export declare const AUTHENTICATION_METHODS: {
    ID_AND_PASSWORD: "openyolo://id-and-password";
    GOOGLE: "https://accounts.google.com";
    FACEBOOK: "https://www.facebook.com";
    LINKEDIN: "https://www.linkedin.com";
    MICROSOFT: "https://login.live.com";
    PAYPAL: "https://www.paypal.com";
    TWITTER: "https://twitter.com";
    YAHOO: "https://login.yahoo.com";
} & {
    readonly [key: string]: any;
};
