export declare function generateId(): string;
export declare function noDataValidator(value: any): boolean;
export declare function stringValidator(value: any): boolean;
export declare class PromiseResolver<T> {
    readonly promise: Promise<T>;
    protected resolveFn: ((result?: T) => void) | null;
    protected rejectFn: ((error: Error) => void) | null;
    constructor();
    resolve(result?: T): void;
    reject(error: Error): void;
    dispose(): void;
}
export declare class TimeoutPromiseResolver<T> extends PromiseResolver<T> {
    private timeoutError;
    private timeoutId;
    constructor(timeoutError: Error, timeoutMs: number);
    resolve(result?: T): void;
    reject(error: Error): void;
    private timeoutReject();
}
export declare function timeoutPromise<T>(error: Error, timeoutMs: number): Promise<T>;
